﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Common;

namespace DbProviderTest
{
    class Program
    {
        public static void Main(String[] args)
        {
            List<string> badProviders;
            List<string> goodProviders = getDbProviders(out badProviders);

            Console.WriteLine("Good providers");
            for (int i = 0; i < goodProviders.Count; i++)
            {
                Console.WriteLine(goodProviders[i]);
            }

            Console.WriteLine("\nBad providers");
            for (int i = 0; i < badProviders.Count; i++)
            {
                Console.WriteLine(badProviders[i]);
            }

            Console.ReadKey();
        }

        private static List<string> getDbProviders(out List<string> badProviders)
        {
            DataTable tbl = DbProviderFactories.GetFactoryClasses();
            List<string> goodProviders = new List<string>();
            badProviders = new List<string>();

            foreach (DataRow row in tbl.Rows)
            {
                string name = row[0] as string;
                string invariantName = row[2] as string;
                try
                {
                    DbProviderFactories.GetFactory(invariantName);
                    goodProviders.Add(name);
                }
                catch (Exception ex)
                {
                    badProviders.Add(name);
                }
            }

            return goodProviders;
        }
    }
}
